Unit DPMI;

Interface

Uses
{$IFDEF MSDOS}
    DOS
{$ELSE}
    WinDOS,
  {$IFDEF Windows}
     WinProcs
  {$ELSE}
     WinAPI
  {$ENDIF}
  {$ENDIF}
     ;

Type
  PtrRec = record
             Ofs, Seg : Word;
           end;

{------------------------------------------------------------------------------}
function GetDOSMem (var RealModePointer, ProtectedModePointer; Size : Word) : Boolean;
{------------------------------------------------------------------------------}
function FreeDOSMem (ProtectedModePointer : Pointer; Size : Word) : Boolean;
{------------------------------------------------------------------------------}
function RealIntr (IntNo : Byte; var Regs) : Boolean;
{------------------------------------------------------------------------------}
function GetMappedDPMIPointer (var ProtectedModePointer; RealModePointer : Pointer) : Boolean;
{------------------------------------------------------------------------------}
function FreeMappedDPMIPointer (ProtectedModePointer : Pointer) : Boolean;
{------------------------------------------------------------------------------}

Implementation

{$IFNDEF MSDOS}
  Type
    TDPMIRegisters = record
                       EDI, ESI, EBP, Res, EBX, EDX, ECX, EAX : Longint;
                       Flags, ES, DS, FS, GS, IP, CS, SP, SS  : Word;
                     end;
{$ENDIF}

{------------------------------------------------------------------------------}

function GetDOSMem;

var
  PRealMode      : Pointer absolute RealModePointer;
  PProtectedMode : Pointer absolute ProtectedModePointer;
{$IFNDEF MSDOS}
  Result         : Longint;
{$ENDIF}

begin  (* GetDOSMem *)
{$IFDEF MSDOS}
  GetMem (PRealMode, Size);
  PProtectedMode:=PRealMode;
  GetDOSMem:=PRealMode <> Nil;
{$ELSE}
  Result:=GlobalDOSAlloc (Size);
  If (Result <> 0) then
    begin
      PRealMode     :=Ptr (HIWORD (Result), 0);
      PProtectedMode:=Ptr (LOWORD (Result), 0);
      GetDOSMem:=True;
    end
  Else GetDOSMem:=False;
{$ENDIF}
end;   (* GetDOSMem *)

{------------------------------------------------------------------------------}

function FreeDOSMem;

begin  (* FreeDOSMem *)
{$IFDEF MSDOS}
  FreeMem (ProtectedModePointer, Size);
  FreeDOSMem:=True;
{$ELSE}
  FreeDOSMem:=GlobalDOSFree (PtrRec (ProtectedModePointer).Seg) = 0;
{$ENDIF}
end;   (* FreeDOSMem *)

{------------------------------------------------------------------------------}

function RealIntr; {$IFNDEF MSDOS} assembler; {$ENDIF}

{$IFDEF MSDOS}
  var
    Reg : Registers absolute Regs;
{$ELSE}
  var
    DPMIregs : TDPMIRegisters;
{$ENDIF}

{$IFDEF MSDOS}
  begin  (* RealIntr *)
    Intr (IntNo, Reg);
    RealIntr:=True;
{$ELSE}
  asm
    push ds
    lds si, Regs
    mov ax, ss;
    mov es, ax;
    lea di, DPMIregs
    cld
    xor ax, ax
    add si, 12
    movsw;  stosw
    sub si, 4
    movsw;  stosw
    sub si, 4
    movsw;  stosw
    stosw;  stosw
    sub si, 8
    movsw;  stosw
    add si, 2
    movsw;  stosw
    sub si, 4
    movsw;  stosw
    sub si, 6
    movsw;  stosw
    add si, 16
    movsw;
    sub si, 4
    movsw;
    sub si, 4
    movsw;
    mov cx, 6
    rep stosw
    lea di, DPMIregs
    mov ax, 0300h
    xor bx, bx
    mov bl, IntNo
    xor cx, cx
    int 31h
    mov ax, 0
    jc @@ExitPoint
    les di, Regs
    mov ax, ss;
    mov ds, ax;
    lea si, DPMIregs
    cld
    add si, 28; movsw
    sub si, 14; movsw
    add si, 6;  movsw
    sub si, 6;  movsw
    sub si, 14; movsw
    sub si, 6;  movsw
    sub si, 6;  movsw
    add si, 34; movsw
    sub si, 4;  movsw
    sub si, 4;  movsw
    mov ax, 1
  @@ExitPoint:
    pop ds
{$ENDIF}
  end;   (* RealIntr *)

{------------------------------------------------------------------------------}

function GetMappedDPMIPointer; {$IFNDEF MSDOS} assembler; {$ENDIF}

{$IFDEF MSDOS}
var
  PProtectedMode : Pointer absolute ProtectedModePointer;

  begin  (* GetMappedDPMIPointer *)
    PProtectedMode:=RealModePointer;
    GetMappedDPMIPointer:=True;
{$ELSE}
  asm
    xor ax, ax
    mov cx, 1
    int 31h
    jc @@Error
    xchg ax, bx
    xor ax, ax
    mov dx, RealModePointer.Word[2]
    mov al, dh
    mov cl, 4
    shr ax, cl
    shl dx, cl
    xchg ax, cx
    mov ax, 7
    int 31h
    jc @@Error
    mov ax, 8
    xor cx, cx
    mov dx, $FFFF
    add dx, RealModePointer.Word [0]
    jnc @@1
    xor dx, dx
    dec dx
  @@1:
    int 31h
    jc @@Error
    cld
    les di, ProtectedModePointer
    mov ax, RealModePointer.Word[0]
    stosw
    xchg ax, bx
    stosw
    mov ax, 1
    jmp @@Exit
  @@Error:
    xor ax, ax
  @@Exit:
{$ENDIF}
  end;   (* GetMappedDPMIPointer *)

{------------------------------------------------------------------------------}

function FreeMappedDPMIPointer; {$IFNDEF MSDOS} assembler; {$ENDIF}

{$IFDEF MSDOS}
  begin  (* FreeMappedDPMIPointer *)
    FreeMappedDPMIPointer:=True;
{$ELSE}
  asm
    mov ax, 1
    mov bx, ProtectedModePointer.Word[2]
    int 31h
    mov ax, 0
    jc @@Error
    inc ax
  @@Error:
{$ENDIF}
  end;   (* FreeMappedDPMIPointer *)

{------------------------------------------------------------------------------}

End.
